import java.net.*;
import java.io.*;
public class SocketHttpClient
{

	private static int modtagHeader(BufferedReader bufferedReader) throws IOException
	{
		System.out.println("Modtaget Header:");
		int contentLength = 0;
		String inTekst = bufferedReader.readLine(); 		 
		while (inTekst != null && inTekst.length() > 0)
		{
			if (inTekst.length() > 16 && inTekst.substring(0,16).compareToIgnoreCase("Content-Length: ") == 0)
				contentLength = Integer.parseInt(inTekst.substring(16));
			else if (inTekst.compareToIgnoreCase("Transfer-Encoding: chunked") == 0)
					contentLength = -1;
			System.out.println("\""+inTekst+"\"");
			inTekst = bufferedReader.readLine();
		}
		return contentLength;
	}

	private static void modtagData(BufferedReader bufferedReader, int contentLength) throws IOException
	{
		System.out.println("Modtaget Data (Content-Length: "+contentLength+"):");
		for (int i = 0; i < contentLength; i++)
		{
			int tegn = bufferedReader.read();
			System.out.print((char)tegn);
		}
		System.out.println("");
	}

	private static void modtagData(BufferedReader bufferedReader) throws IOException
	{
		// Transfer-Encoding: chunked
		System.out.println("Modtaget Data (Transfer-Encoding: chunked):");
		String inTekst = bufferedReader.readLine(); 		 
		int antalTomme = 0;
		while (inTekst != null && antalTomme < 3)
		{
			if (inTekst.length() == 0) antalTomme++;
			else											 antalTomme = 0;
			System.out.println(">"+inTekst+"<");
			inTekst = bufferedReader.readLine();			
		}
	}

	private static String getSendTekst (String urlAdresse, String webPage)
	{
    String newline = "" + (char)(13) + (char)(10); 
    String sendTekst = ""
     + "GET "+webPage+" HTTP/1.1"+newline
     + "Host: "+urlAdresse+""+newline
     + "Connection: close"+newline						// anden mulighed  "Connection: Keep-Alive\n"
     + ""+newline;														// slut med blank linie efter header
		return sendTekst; 	 
	}

	public static void main(String[] args)
	{
		try
		{
			int port = 80;
			String urlAdresse = "www.uv.tietgen.dk";
			String webPage = "/staff/bjbu/Netvaerk/test.txt"; 		
			String sendTekst = getSendTekst(urlAdresse, webPage);

			System.out.println("Start p forbindelse");
			Socket socket = new Socket(urlAdresse,port);
			OutputStream outputStream = socket.getOutputStream();
			PrintWriter printWriter = new PrintWriter(outputStream,true);

			printWriter.print(sendTekst);
			printWriter.flush(); 

			System.out.println("Sendt:"+sendTekst.length());
			System.out.println(sendTekst);

			InputStream inputStream = socket.getInputStream();
			InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
			BufferedReader bufferedReader = new BufferedReader(inputStreamReader);

			int contentLength = modtagHeader(bufferedReader);
			if (contentLength > 0)
				modtagData(bufferedReader, contentLength);
			else if (contentLength < 0) 		// Transfer-Encoding: chunked
				modtagData(bufferedReader);

			System.out.println("Slut p data");
			socket.close(); 					 
		}
		catch (Exception e)
		{
				System.out.println("Exception:"+e);
		}
		System.out.println("Slut p client");
		
	}
}
